<?php
class Transliterate_Controller extends Controller {
	protected $_transliterator;
	public static $allowed_actions = array (
		'Convert'
	);
	public function getTransliterator() {
		if ( null === $this->_transliterator ) $this->_transliterator = new Transliterator();
		return $this->_transliterator;
	}
	public function Convert( $request ) {
		$text = $request->requestVar( 'text' );
		$lc = $request->requestVar( 'lc' );
		$json = $request->requestVar( 'json' );
		$convertedText = Transliterator::transliterate( $text, $lc );		
		return ( !$json ? $convertedText : $this->renderWith( 'Transliterate', array( 'convertedText'=>json_encode( array( 'convertedText'=>$convertedText ) ) ) ) );
	}
}
class Transliterator {
	protected static $_dataFile;
	protected static $_fp;
	protected static $_dataPos;
	public function __construct() {
		self::$_dataFile = dirname(__FILE__) . '/Transliterate.dat';
	}
	protected function _init() {
		if ( null === self::$_dataFile ) {
			self::$_dataFile = dirname(__FILE__) . '/Transliterate.dat';
		}
		if ( null === self::$_fp ) {
			self::$_fp = fopen( self::$_dataFile, 'rb' );
			self::$_dataPos = current( unpack( 'N', fread( self::$_fp, 4 ) ) );
		}
	}
	public function transliterate( $string, $toLower = true, $maxLen = 255 ) {
		if ( !SiteTree::canCreate() || !SiteTree::canEdit())  Security::permissionFailure;
		$transString = '';
		$len = mb_strlen( $string, 'UTF-8' );
		for ( $i = 0; $i < $len; $i++ ) {
			$char = mb_substr( $string, $i, 1, 'UTF-8' );
			$transChar = ( !preg_match( "/[A-Za-z0-9\.\+\-\_\=]/", $char ) ? self::transliterateChar( $char ) : $char );
			if ( null === $transChar ) $transChar = $char;
			$transString .= $transChar;
		}
		// Pike I've the troubles, so I removed this
		//$transString = preg_replace( '#^-|-$#', '', preg_replace( '#-{2,}#', '-', preg_replace( '#[^\w]#', '-', $transString ) ) );
		// Pike I've the troubles, so I removed this
		if ( $toLower ) $transString = strtolower( $transString );
		if ( strlen( $transString ) > $maxLen ) {
			$transString = ( preg_match( '#^.{0,' . $maxLen . '}(-|$)#', $transString, $matches ) ? $matches[0] : substr( $transString, 0, $maxLen ) );
			$transString = rtrim( $transString, '-' );
		}
		return $transString;
	}
	protected function transliterateChar( $char ) {
		self::_init();
		$translitedChar = null;
		$start = 0;
		$end = self::$_dataPos/8;
		while ( $end >= $start ) {
			$center = floor( ( $start + $end ) / 2 );
			fseek( self::$_fp, 4 + $center * 8 );
			$readChar = rtrim( fread( self::$_fp, 4 ), "\0" );
			if ( rtrim( $readChar, "\0") == $char ) {
				$pos = current( unpack( 'N', fread( self::$_fp, 4 ) ) );
				fseek( self::$_fp, 4 + self::$_dataPos + $pos );
				$len = current( unpack( 'C', fread( self::$_fp, 1 ) ) );
				$translitedChar = fread( self::$_fp, $len );
				break;
			} 
			elseif ( $char > $readChar ) {
				$start = $center + 1;
			} 
			else {
				$end = $center - 1;
			}
		}
		return $translitedChar;
	}
}
?>